Index: branches/mount_points/src/lib/graphics/importer/Makefile.am
===================================================================
--- branches/mount_points/src/lib/graphics/importer/Makefile.am	(revision 10048)
+++ branches/mount_points/src/lib/graphics/importer/Makefile.am	(revision 10050)
@@ -25,4 +25,6 @@
 		\
 		obj/objModel.cc \
+		\
+		oif/object_information_file.cc \
 		\
 		bsp/bsp_manager.cc \
@@ -79,4 +81,6 @@
 		obj/objModel.h \
 		\
+		oif/object_information_file.h \
+		\
                 md2/md2Model.h \
 		md2/resource_md2.h \
Index: branches/mount_points/src/lib/graphics/importer/oif/object_information_file.cc
===================================================================
--- branches/mount_points/src/lib/graphics/importer/oif/object_information_file.cc	(revision 10050)
+++ branches/mount_points/src/lib/graphics/importer/oif/object_information_file.cc	(revision 10050)
@@ -0,0 +1,38 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli patrick@orxonox.net
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "object_information_file.h"
+
+
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+ObjectInformationFile::ObjectInformationFile(float sizeX, float sizeY, unsigned int rows, unsigned int columns)
+{
+}
+
+
+/**
+ * standard deconstructor
+*/
+ObjectInformationFile::~ObjectInformationFile ()
+{
+  // delete what has to be deleted here
+}
Index: branches/mount_points/src/lib/graphics/importer/oif/object_information_file.h
===================================================================
--- branches/mount_points/src/lib/graphics/importer/oif/object_information_file.h	(revision 10050)
+++ branches/mount_points/src/lib/graphics/importer/oif/object_information_file.h	(revision 10050)
@@ -0,0 +1,27 @@
+/*!
+ * @file object_information_file.h
+ * @brief Definition of a class that helps defining mount point connections
+*/
+
+#ifndef _OBJECT_INFORMATION_FILE_H
+#define _OBJECT_INFORMATION_FILE_H
+
+#include "vertex_array_model.h"
+
+
+
+//! A class for object informations
+class ObjectInformationFile : public VertexArrayModel
+{
+
+public:
+  ObjectInformationFile();
+  virtual ~ObjectInformationFile();
+
+
+
+private:
+
+};
+
+#endif /* _OBJECT_INFORMATION_FILE_H */
Index: branches/mount_points/src/world_entities/WorldEntities.am
===================================================================
--- branches/mount_points/src/world_entities/WorldEntities.am	(revision 10048)
+++ branches/mount_points/src/world_entities/WorldEntities.am	(revision 10050)
@@ -24,4 +24,5 @@
                 world_entities/planet.cc \
                 world_entities/bsp_entity.cc \
+                world_entities/mount_point.cc \
                 \
                 world_entities/weapons/test_gun.cc \
@@ -127,4 +128,5 @@
                 planet.h \
                 bsp_entity.h \
+                mount_point.h \
                 \
                 weapons/test_gun.h \
Index: branches/mount_points/src/world_entities/mount_point.cc
===================================================================
--- branches/mount_points/src/world_entities/mount_point.cc	(revision 10050)
+++ branches/mount_points/src/world_entities/mount_point.cc	(revision 10050)
@@ -0,0 +1,118 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer:
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "executor/executor.h"
+#include "util/loading/factory.h"
+#include "util/loading/load_param.h"
+
+
+#include "mount_point.h"
+#include "debug.h"
+
+
+
+
+#include "state.h"
+
+
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinition(MountPoint);
+CREATE_FACTORY(MountPoint);
+
+
+
+/**
+ * construct
+ */
+MountPoint::MountPoint ()
+{
+  this->init();
+}
+
+
+/**
+ * constructor
+ * @param root the xml root element
+ */
+MountPoint::MountPoint(const TiXmlElement* root)
+{
+  this->init();
+
+  if( root != NULL)
+    this->loadParams(root);
+}
+
+
+/**
+ * deconstructor
+ */
+MountPoint::~MountPoint ()
+{}
+
+
+/**
+ * initializing function
+ */
+void MountPoint::init()
+{
+  this->registerObject(this, MountPoint::_objectList);
+  this->toList(OM_GROUP_00);
+}
+
+
+/**
+ * loads the Settings of a MD2Creature from an XML-element.
+ * @param root the XML-element to load the MD2Creature's properties from
+ */
+void MountPoint::loadParams(const TiXmlElement* root)
+{
+  WorldEntity::loadParams(root);
+}
+
+
+
+/**
+ * tick
+ * @param time  time passed since the last tick
+ */
+void MountPoint::tick (float time)
+{
+
+
+}
+
+
+/**
+ * draw this entity
+ */
+void MountPoint::draw() const
+{
+
+}
+
+
+
+/**
+ *  function called to draw the mount point itself for debug purposes only
+ */
+void MountPoint::debugDraw() const
+{
+
+}
Index: branches/mount_points/src/world_entities/mount_point.h
===================================================================
--- branches/mount_points/src/world_entities/mount_point.h	(revision 10050)
+++ branches/mount_points/src/world_entities/mount_point.h	(revision 10050)
@@ -0,0 +1,29 @@
+#ifndef _MOUNT_POINT_H
+#define _MOUNT_POINT_H
+
+#include "world_entity.h"
+
+class TiXmlElement;
+
+
+class MountPoint : public WorldEntity
+{
+    ObjectListDeclaration(MountPoint);
+
+  public:
+    MountPoint ();
+    MountPoint(const TiXmlElement* root);
+    virtual ~MountPoint ();
+
+    void init();
+    virtual void loadParams(const TiXmlElement* root);
+
+
+    virtual void tick (float time);
+    virtual void draw() const;
+
+    void debugDraw() const;
+
+};
+
+#endif /* _MOUNT_POINT_H */