Index: /code/branches/modularships/data/levels/templates/ModularSpaceShipTest.oxt
===================================================================
--- /code/branches/modularships/data/levels/templates/ModularSpaceShipTest.oxt	(revision 10053)
+++ /code/branches/modularships/data/levels/templates/ModularSpaceShipTest.oxt	(revision 10054)
@@ -57,5 +57,14 @@
         </StaticEntity>
         
-        <StaticEntity name="two" position="0,0,60" direction="0,0,0" collisionType=static mass=100 friction=0.01 >
+        <StaticEntity name="two" position="0,0,62" direction="0,0,0" collisionType=static mass=100 friction=0.01 >
+            <attached>
+                <Model position="0,0,0" mesh="cube.mesh" scale3D="30,30,30" />
+            </attached>
+            <collisionShapes>
+                <BoxCollisionShape position="0,0,0" halfExtents="30,30,30" />
+            </collisionShapes>
+        </StaticEntity>
+        
+        <StaticEntity name="two_2" position="0,0,124" direction="0,0,0" collisionType=static mass=100 friction=0.01 >
             <attached>
                 <Model position="0,0,0" mesh="cube.mesh" scale3D="30,30,30" />
@@ -75,5 +84,14 @@
         </StaticEntity>
         
-        <StaticEntity name="four" position="0,0,-60" direction="0,0,0" collisionType=static mass=100 friction=0.01 >
+        <StaticEntity name="four" position="0,0,-59" direction="0,0,0" collisionType=static mass=100 friction=0.01 >
+            <attached>
+                <Model position="0,0,0" mesh="cube.mesh" scale3D="30,30,30" />
+            </attached>
+            <collisionShapes>
+                <BoxCollisionShape position="0,0,0" halfExtents="30,30,30" />
+            </collisionShapes>
+        </StaticEntity>
+        
+        <StaticEntity name="four_2" position="0,0,-118" direction="0,0,0" collisionType=static mass=100 friction=0.01 >
             <attached>
                 <Model position="0,0,0" mesh="cube.mesh" scale3D="30,30,30" />
@@ -87,8 +105,10 @@
     
     <parts>
-        <ShipPart name="one" initialhealth="15" damageabsorption="1" />
-        <ShipPart name="two" initialhealth="15" damageabsorption="1" />
-        <ShipPart name="three" initialhealth="18" damageabsorption="1" />
+        <ShipPart name="one" initialhealth="20" damageabsorption="1" />
+        <ShipPart name="two" initialhealth="20" damageabsorption="1" />
+        <ShipPart name="two_2" initialhealth="20" damageabsorption="1" />
+        <ShipPart name="three" initialhealth="20" damageabsorption="1" />
         <ShipPart name="four" initialhealth="20" damageabsorption="1" />
+        <ShipPart name="four_2" initialhealth="20" damageabsorption="1" />
     </parts>
     
Index: /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.cc
===================================================================
--- /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10053)
+++ /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10054)
@@ -128,32 +128,7 @@
         this->partMap_[entity] = part;
 
-        //This adds a list of SmartPointers for all StaticEntities which have a ShipPart, preventing them from getting deleted. Hopefully.
-        SmartPtr<StaticEntity> newSmartPtr = entity;
-        SmartPtr<StaticEntity>* one = &newSmartPtr;
-        this->entityPtrList_.push_back(one);
-
-        //this->createCSPtrList(this->getWorldEntityCollisionShape());
-
         orxout() << "New entity-part assignment created!" << endl;
     }
 
-    // This should add smartPointers to all (Orxonox)Collisionshapes of this SpaceShip, preventing them fromg etting deleted. Might not work due to weird acting getAttachedShape
-    void ModularSpaceShip::createCSPtrList(CompoundCollisionShape* cs) // FIXME: (noep) remove debug
-    {
-        for (int i=0; i < cs->getNumChildShapes(); i++)
-        {
-
-            if (!orxonox_cast<CompoundCollisionShape*>(cs->getAttachedShape(i)))
-            {
-                SmartPtr<CollisionShape> newSmartPtr = cs->getAttachedShape(i);
-                SmartPtr<CollisionShape>* one = &newSmartPtr;
-                this->csPtrList_.push_back(one);
-            }
-
-            if (orxonox_cast<CompoundCollisionShape*>(cs->getAttachedShape(i)))
-                createCSPtrList((CompoundCollisionShape*)(cs->getAttachedShape(i)));
-
-        }
-    }
 
     /**
@@ -305,5 +280,5 @@
             {
                 this->detach(itt->first);
-                //itt->first->destroy();
+                itt->first->destroy();
                 //itt->first->setActive(false);
                 //itt->first->setVisible(false);
Index: /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.h
===================================================================
--- /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.h	(revision 10053)
+++ /code/branches/modularships/src/orxonox/worldentities/pawns/ModularSpaceShip.h	(revision 10054)
@@ -122,6 +122,4 @@
             virtual void updatePartAssignment();
 
-            void createCSPtrList(CompoundCollisionShape* cs);
-
         protected:
 